<!DOCTYPE html>
<html lang="en">
<head>
   <meta charset="UTF-8">
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   <title>Diagrama PlantUML</title>
   
   <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" rel="stylesheet">
   <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>
</head>


<body>


   <div class="row">
       <div class="col-md-10 m-auto my-5">
           <div class="card">
               <div class="card-header">
                   <strong>Diagrama de clases con PlantUML S    erver (PIM)</strong>
               </div>
               <div class="card-body">
                   <p>
                       Ejemplo librería <a target="_blank" href="https://plantuml.com/es/">PlantUML</a>  y
                       <a target="_blank" href="https://plantuml.com/es/server">PlantUMLserver</a>
                       para crear diagramas a partir de texto y su
                       <a target="_blank" href="https://www.plantuml.com/plantuml/uml/SyfFKj2rKt3CoKnELR1Io4ZDoSa70000">
                           Live editor
                       </a>
                   </p>
              
                   <div id="diagrama"></div>


               </div>
           </div>
       </div>
   </div>


   <script>
       $(document).ready(function() {
          

           var plantUmlServicio = 'http://localhost:8080/plantuml/png/';
           var plantUmlCode = `
               @startuml
               class Paginaweb {
               -nombre: string
               +getNombre(): string
               +setNombre(nombre: string): void
               }
               $(document).ready

               class Header {
               +titulo: string
               +nombre: double
               }


               class Paragraph {
               +texto: string
               }


               class Footer {
               +info: string
               }
              
               Paginaweb "1" *-- "1" Header : tiene
               Paginaweb "1" *-- "0..*" Paragraph : tiene
               Paginaweb "1" *-- "1" Footer : tiene
               @enduml
           `;

           // opción 1
           $.ajax({
               type: "POST",
               url: plantUmlServicio,
               data: plantUmlCode,
               contentType: "text/plain",
               xhrFields:{responseType: 'blob'},
               success: function(data) {
                   const imgUrl = URL.createObjectURL(data);
                   const img = document.createElement('img');
                   img.src = imgUrl;
                   $("#diagrama").html(img);
               },
               error: function(xhr, status, error) {
                   console.error("Error:", error);
               }
           });

           // opción 2
           /*fetch(plantUmlServicio,
               {
                   method: 'POST',
                   headers: {'Content-Type': 'text/plain'},
                   body: plantUmlCode
               }).then(response => {
                   if (!response.ok) {
                       throw new Error('Ocurrió un error al generar el diagrama PNG');
                   }
                   return response.blob();
               }).then(blob => {
   
                   const imgUrl = URL.createObjectURL(blob);
                   const img = document.createElement('img');
                   img.src = imgUrl;
                   $("#diagrama").html(img);


               }).catch(error => {
                   console.error('Error:', error);
               });*/

       });
   </script>
</body>
</html>